﻿	jp Main

; Stores the number of times On has been pressed.
OnKeyCount
	.dw 0

; Interrupt stuff.
InterruptBase     = $98
InterruptTable    = (InterruptBase << 8) + $200
InterruptLocation = InterruptBase | (InterruptBase << 8)

; ISR
Handler
$ = InterruptLocation
RelocatedHandler
	push af
	push hl
	
	in a,(4)

	bit 0,a
	jr z,InterruptNotOnKey
		push af
		ld hl,(OnKeyCount)
		inc hl
		ld (OnKeyCount),hl
		pop af
	InterruptNotOnKey
	
	; Acknowledge/re-enable:
	ld a,%00001000 ; Disable/ack all interrupts; keep calc powered.
	out (3),a
	ld a,%00001001 ; Enable ON key.
	out (3),a
	
	pop hl
	pop af
	ei
	reti
RelocatedHandlerEnd
$ = @
HandlerEnd


; Main entry point.
Main

	.bcall _ClrLcdFull

	; Load the ISR

	di

	ld hl,Handler
	ld de,InterruptLocation
	ld bc,HandlerEnd-Handler
	ldir
	
	ld hl,InterruptTable
	ld a,InterruptBase
	ld (hl),a
	ld d,h
	ld e,l
	inc de
	ld bc,256
	ldir
	
	ld a,InterruptTable >> 8
	ld i,a

	im 2
	ei
	
	; Call the interrupt handler once, to prime it.
	call Handler
	
	ld hl,0
	ld (OnKeyCount),hl

-	; Draw the counter for the current number of On-key interrupts.
	xor a
	ld (curCol),a
	ld (curRow),a
	ld hl,(OnKeyCount)
	.bcall _dispHL
	ei
	
	; Check for CLEAR
	ld a,$FF
	out (1),a
	ld a,$FD
	out (1),a
	in a,(1)
	cp $BF
	jr nz,-
	
	; This can't be healthy, but "it works". :)
	di
	im 1
	call $38
	ret